// ----------------------------------------------------------------------------------------------------
// configrable settings for layout
// ----------------------------------------------------------------------------------------------------
var Skin					=	"skins\\alfred-like\\";
var SkinWidth				=	500;
var SkinHeight				=	300;
var SkinBorder				=	10;
	
var SkinHeaderHeight		=	45;					// header height
var SkinHeaderBorder		=	20;					// padding for the side
var SkinHeaderTop			=	SkinBorder;			// header position (Y)

	
var SkinColumns			=	2;
var SkinColumnHeight 		=	200;
var SkinColumnBorder		=	20;
var SkinColumnTop			= 	SkinHeaderTop + SkinHeaderHeight;
var SkinColumnWidth 		=	(SkinWidth / SkinColumns) - (SkinColumnBorder+SkinBorder);

var SkinFooterBorder		=	20;
var SkinFooterColumns		=	3;
var SkinFooterTop			=	SkinColumnTop + SkinColumnHeight;
var SkinFooterHeight 		=	SkinHeight - (SkinFooterTop + SkinBorder);
var SkinFooterColumnWidth	=	(SkinWidth / SkinFooterColumns) - (SkinFooterBorder+SkinBorder);

// ----------------------------------------------------------------------------------------------------
// configrable settings for controls
// ----------------------------------------------------------------------------------------------------
/* for the Input Box in the header*/
var InputBoxHeight			=	45;										// box where you type
var InputBoxTextSize		=	12;										// box where you type
var InputBoxTextColor		=	0x88000000;										// box where you type

/* for the Results List Box in the first Column */
var ResultsRunOff			=	25;										// how much to chop of the results (so we can show text below)
var ResultsRunOffText		=	"... arrow down for more ...";
var ResultsRunOffTextSize	=	8;										// size of the text 

	/* when theres no List Box */
	var NoResultsText			=	"start typing ..... ";
	var NoResultsOffset			=	150;									// Y offset of the NoResults Text
	var NoResultsTextSize		=	12;
	var NoResultsHeight			=	50;									// height of the text box 
	var NoResultsImage			=	Skin+"\\qatapult.png";					// recomend 256x256
	var NoResultsImageX			=	220;
	var NoResultsImageY			=	0;
	var NoResultsImageHeight		=	256;
	var NoResultsImageWidth		=	256;

/* for the Properties of the item (Info Box) in the second Column */	
var FreeTextImage 			= 	"icons\\edit.png";

var InfoBoxImageSidePadding	= 	50;										// amount of space ether side of the image relative to SkinColumnWidth
var InfoBoxImageTopPadding	= 	0;										// amount of space to drop down relative to SkinColumnTop
var InfoBoxImageWidth		=	SkinColumnWidth - (InfoBoxImageSidePadding * 2);	// recomended - the size of the space avlivble
var InfoBoxImageHeight		=	SkinColumnWidth - (InfoBoxImageSidePadding * 2);	// recomended as above to make it squaire

var InfoBoxHeadingPadding	=	5;										// relative to the bottom of the image 
var InfoBoxHeadingHeight		=	20;										// heading size for the item information on the right
var InfoBoxHeadingTextSize	=	12;										// heading size for the item information on the right
var InfoBoxHeadingTextColor	=	0x88000000;

var InfoBoxPadding			= 	5;										// relative to the InfoBoxHeading
var InfoBoxHeight			=	10;										// normal size for the item information on the right
var InfoBoxTextSize			=	8;										// normal size for the item information on the right
var InfoBoxTextColor		=	0x88000000;


/* for the Selected items in the footer */
var SelectedItemHeight		=	36;

// ---------------------------------------------------------------------------------------------------- // ---------------------------------------------------------------------------------------------------- //
// ---------------------------------------------------------------------------------------------------- // ---------------------------------------------------------------------------------------------------- //
// ---------------------------------------------------------------------------------------------------- // ---------------------------------------------------------------------------------------------------- //
// ---------------------------------------------------------------------------------------------------- // ---------------------------------------------------------------------------------------------------- //

function draw(ui) 
{
	// set the text color
	ui.textcolor	=	InputBoxTextColor;
	ui.fontsize	=	InputBoxTextSize;
	// draw the canvas
	ui.drawBitmap(Skin+"background.png", 0, 0, SkinWidth, SkinHeight);
	// draw the input box
	ui.drawInput(SkinBorder + SkinHeaderBorder, SkinHeaderTop + SkinHeaderHeight - SkinHeaderBorder, SkinWidth - ((SkinBorder + SkinHeaderBorder)*2),InputBoxHeight);

	// now draw the items - pane one
	if(qatapult.argscount==1)
	{
		drawItem( ui, 0, SkinBorder + SkinFooterBorder, SkinFooterTop, SkinFooterColumnWidth, SelectedItemHeight);
	}
	// now draw the items - pane two
	if (qatapult.argscount==2)
	{
		drawItem( ui, 0, SkinBorder + SkinFooterBorder, SkinFooterTop, SkinFooterColumnWidth, SelectedItemHeight );
		drawItem( ui, 1, (SkinBorder + SkinFooterBorder) + SkinFooterColumnWidth, SkinFooterTop, SkinFooterColumnWidth, SelectedItemHeight );
	}
	// now draw the items - pane three
	if (qatapult.argscount==3)
	{
		drawItem( ui, 0, SkinBorder + SkinFooterBorder, SkinFooterTop, SkinFooterColumnWidth, SelectedItemHeight );
		drawItem( ui, 1, (SkinBorder + SkinFooterBorder) + SkinFooterColumnWidth, SkinFooterTop, SkinFooterColumnWidth, SelectedItemHeight );
		drawItem( ui, 2, (SkinBorder + SkinFooterBorder) + (SkinFooterColumnWidth * 2), SkinFooterTop, SkinFooterColumnWidth, SelectedItemHeight);
	}
	
	// draw results box
	if(qatapult.resultscount!=0) 
	{
		var resultscount=Math.min(5,qatapult.resultscount);
		// >  ----------------------------------------------------------
		// >  new version might allow the background or color of the results box
		// >  to change - revisit if this happens as we need to set it here
		//  >  ----------------------------------------------------------
		ui.drawResults(SkinBorder, SkinColumnTop , SkinColumnWidth, SkinColumnHeight - ResultsRunOff);
		if (qatapult.resultscount>4)
		{
			ui.fontsize	=	ResultsRunOffTextSize;
			ui.drawText(ResultsRunOffText, SkinBorder,SkinColumnTop +(SkinColumnHeight-ResultsRunOff),SkinColumnWidth, ResultsRunOff); 
		}
		//draw a black arrow to indicate where you are!
		var focus=qatapult.getFocus(); 
		if(focus==0)
		{
			ui.drawBitmap(Skin+"tab.png", SkinBorder, SkinFooterTop + ((SkinFooterHeight -15)/2), 15, 15);
		}
		if (focus==1)
		{
			ui.drawBitmap(Skin+"tab.png", SkinBorder + SkinFooterColumnWidth, SkinFooterTop + ((SkinFooterHeight -15)/2), 15, 15);
		}
		if (focus==2)
		{
			ui.drawBitmap(Skin+"tab.png", SkinBorder + (SkinFooterColumnWidth * 2), SkinFooterTop + ((SkinFooterHeight -15)/2), 15, 15);
		}
	}	
	else
	{
		ui.fontsize	=	NoResultsTextSize;
		ui.drawText(NoResultsText, SkinBorder + SkinColumnBorder ,SkinColumnTop + NoResultsOffset, SkinColumnWidth, NoResultsHeight); 
		ui.drawBitmap(NoResultsImage,NoResultsImageX, NoResultsImageY, NoResultsImageHeight, NoResultsImageWidth);
	}	
	
	if(qatapult.argscount>1)
	{
		// set up vars to be used in the info box
		var picture 	= 	"";
		var heading 	= 	"";
		var item1 	= 	"";
		var item2 	= 	"";
		var item3 	= 	"";
		
		// whats the type?
		type = qatapult.getArgValue(0, "type");
		
		if (type == "TEXT")
		{			
			// display the image of the object
			picture 	= 	FreeTextImage;
			heading 	= 	"free text";
			item1 	=	qatapult.getArgValue(0, "status")			
		}
		if (type == "WINDOW")
		{	
			// draw the frame - this can be used for images or something.
			ui.drawBitmap(Skin+"frame.png", SkinBorder + SkinColumnBorder + SkinColumnWidth + InfoBoxImageSidePadding ,SkinColumnTop + InfoBoxImageTopPadding, InfoBoxImageWidth, InfoBoxImageHeight);
			
			winTitle 		= qatapult.getArgValue(0, "title"); 
			winHWD 		= qatapult.getArgValue(0, "hwnd");
			text 		= qatapult.getArgValue(0, "text");
			heading		= "Window";
			item1 		= winTitle;
			item2 		= "Window ID : " + winHWD;	
		}
		if (type == "FILE")
		{
			var fileext	= 	"";
		
			// what is the file and where is it. We'll need this most of the time in the if statements below. Get it early then.
			filedir = qatapult.getArgValue(0, "directory") 
			filename = qatapult.getArgValue(0, "filename") 
			
			// Time to work out the extention. WIth this we can target the best properties of an object to display
			fileext = filename.substring(filename.length,filename.length-4);
			// lower case the extension then it doesnt matter is its .xxx or .XXX or .XxX - we still know it
			fileext = fileext.toLowerCase()

			if ((fileext == ".png")||(fileext == ".jpg")||(fileext == ".bmp"))
			{
				heading 	= 	"Image";
				picture 	= 	filedir+"\\"+filename;
				
				// draw the picture border
				//ui.drawBitmap(Skin+"frame.png", SkinBorder + SkinColumnBorder + SkinColumnWidth + InfoBoxImageSidePadding ,SkinColumnTop + InfoBoxImageTopPadding, InfoBoxImageWidth, InfoBoxImageHeight);

				item1 	= 	"";
				item2 	= 	"";
				item3 	= 	"";
			}
			else if (fileext == ".mp3")
			{
				heading 	= "Audio";
				// cheap but luckly me i keep cover.jpg in my music folders. - would be nice to rip the thumb from the id3 tag. 
				// ui.drawBitmap(Skin+"frame.png", SkinBorder + SkinColumnBorder + SkinColumnWidth + InfoBoxImageSidePadding ,SkinColumnTop + InfoBoxImageTopPadding, InfoBoxImageWidth, InfoBoxImageHeight);
				picture 	= 	filedir+"\\cover.jpg";
				
				// now lets get the extended properties of the file. 
				// these vaules are diffrent for XP win 7 and vista. Need to make seprate skins for this. 
				// http://www.kixtart.org/forums/ubbthreads.php?ubb=showflat&Number=201630				
				var ARTIST_NAME    = 	16; // Win7 use 216 
				var ALBUM_TITLE    = 	17; // Win7 use 14
				var YEAR		    = 	18; // Win7 use 15

				// need the filename to be an object!
				var oShell  		= 	new ActiveXObject("Shell.Application");
				var oFolder 		= 	oShell.Namespace(filedir);
				var oFile   		= 	oFolder.ParseName(filename);
								
				item1	=	"Artist : " 	+ oFolder.GetDetailsOf(oFile, ARTIST_NAME);
				item2	=	"Album: "		+ oFolder.GetDetailsOf(oFile, ALBUM_TITLE);
				item3	=	"Year: "		+ oFolder.GetDetailsOf(oFile, YEAR);
	
			}
			else if (fileext == ".lnk")
			{
				heading 	= 	"Shortcut";			
				item1	=	qatapult.getArgValue(0, "rfilename");
				item2	=	qatapult.getArgValue(0, "rdirectory");				
			}
			else if (fileext == ".exe")
			{	
				heading = filename;
				// now lets get the extended properties of the file. 
				// these vaules are diffrent for XP win 7 and vista. Need to make seprate skins for this. 
				// http://www.kixtart.org/forums/ubbthreads.php?ubb=showflat&Number=201630				
				var COMPANY_NAME    = 	35;
				var FILE_VERSION    = 	37; // Win7 use 156
				var PROGRAM_DESC    = 	30;

				// need the filename to be an object!
				var oShell  	=	new ActiveXObject("Shell.Application");
				var oFolder 	= 	oShell.Namespace(filedir);
				var oFile   	= 	oFolder.ParseName(filename);
				
				item1	=	"Company Name : " 		+ oFolder.GetDetailsOf(oFile, COMPANY_NAME);
				item2	=	"File Version : "		+ oFolder.GetDetailsOf(oFile, FILE_VERSION);
				item3	=	"Description : "		+ oFolder.GetDetailsOf(oFile, PROGRAM_DESC);
			}
			else
			{
				// now lets get the extended properties of the file. 
				// these vaules are diffrent for XP win 7 and vista. Need to make seprate skins for this. 
				// http://www.kixtart.org/forums/ubbthreads.php?ubb=showflat&Number=201630				
				var FILE_TYPE    	= 	2;
				var DATE_CREATED    = 	4; // Win7 use 156
				var FILE_SIZE	    	= 	1;
				var ATTRIBUTES 	= 	6;

				// need the filename to be an object!
				var oShell  	= 	new ActiveXObject("Shell.Application");
				var oFolder 	= 	oShell.Namespace(filedir);
				var oFile   	= 	oFolder.ParseName(filename);
				
				heading 		= 	oFolder.GetDetailsOf(oFile, FILE_TYPE);		
				item1		=	"Created : " 		+ oFolder.GetDetailsOf(oFile, DATE_CREATED);
				item2		=	"Size : "			+ oFolder.GetDetailsOf(oFile, FILE_SIZE);
				item3		=	"Attributes : "	+ oFolder.GetDetailsOf(oFile, ATTRIBUTES);
			}	
		}
		// --------------------------------------------------------------------------------------------------
		// now to Draw the info Box
		// --------------------------------------------------------------------------------------------------
		
		// display the image of the object
		if (picture !="")
		{
			ui.drawBitmap(picture, SkinBorder + SkinColumnBorder + SkinColumnWidth + InfoBoxImageSidePadding ,SkinColumnTop + InfoBoxImageTopPadding, InfoBoxImageWidth, InfoBoxImageHeight);
		}
		else
		{
			drawItem(ui,0, SkinBorder + SkinColumnBorder + SkinColumnWidth + InfoBoxImageSidePadding ,SkinColumnTop + InfoBoxImageTopPadding, InfoBoxImageWidth, InfoBoxImageHeight);
		}	

		// set text size and color of the Header
		ui.fontsize	=	InfoBoxHeadingTextSize;
		ui.textcolor	=	InfoBoxHeadingTextColor;

		// display the heading of the object
		ui.drawText(heading, SkinBorder + SkinColumnBorder + SkinColumnWidth,SkinColumnTop + InfoBoxImageTopPadding + InfoBoxImageHeight + InfoBoxHeadingPadding,SkinColumnWidth,InfoBoxHeadingHeight); 

		// set text size and color of the info
		ui.fontsize	=	InfoBoxTextSize;
		ui.textcolor	=	InfoBoxTextColor;
		
		// display the text info about the object
		ui.drawText(item1,  SkinBorder + SkinColumnBorder + SkinColumnWidth,SkinColumnTop + InfoBoxImageTopPadding + InfoBoxImageHeight + InfoBoxHeadingPadding + InfoBoxHeadingHeight + InfoBoxPadding,SkinColumnWidth,InfoBoxHeight); 
		ui.drawText(item2,  SkinBorder + SkinColumnBorder + SkinColumnWidth,SkinColumnTop + InfoBoxImageTopPadding + InfoBoxImageHeight + InfoBoxHeadingPadding + InfoBoxHeadingHeight + InfoBoxPadding + InfoBoxHeight,SkinColumnWidth,InfoBoxHeight); 
		ui.drawText(item3,  SkinBorder + SkinColumnBorder + SkinColumnWidth,SkinColumnTop + InfoBoxImageTopPadding + InfoBoxImageHeight + InfoBoxHeadingPadding + InfoBoxHeadingHeight + InfoBoxPadding + (InfoBoxHeight*2),SkinColumnWidth,InfoBoxHeight); 
	}

	// draw the menu button
	ui.drawBitmap(Skin+"ui-radio-button.png", SkinWidth-33, SkinBorder+2, 16, 16);

	// drawn index progress
	ui.fontsize	=	8;
	ui.textcolor	=	0x88000000;
	if(qatapult.crawlprogress!=0 && qatapult.crawlprogress!=100)
	{
        ui.drawText("Updating index : "+qatapult.crawlprogress+"%",SkinBorder,SkinBorder+5,SkinWidth-(SkinBorder*2),15)
	}
		
	
	// determine the mode - will add support for this later.
	/*
    if(qatapult.textmode) 
    {
        //ui.drawBitmap(Skin+"textbackground.png", 0, 0, 350, 200);
        //ui.drawInput(25,25,305,138);
        //height=200;
    } 
    else 
    {
        //ui.textcolor=0xFF000000;
        // draw the background according to the number of current args
        if(qatapult.argscount<3) 
	   {
            //ui.drawBitmap(Skin+"background.png", 0, 0, 350, 120);
            //height=120;
        } 
	   else 
	   {
            //ui.drawBitmap(Skin+"background_3.png", 0, 0, 350, 170);
            //height=170;
        }
    }
    */
}

function drawItem(ui,i,x,y,w,h) 
{    
    if(qatapult.getArgValue(i,"type")=="TEXT") 
    {
		// HELP >  ----------------------------------------------------------
		// HELP > free text always appears in white. Dont know how to set the color?
		// ui.drawItem(i,x+5,y+5,w-10,h-20);
    } 
    else 
    {
        // draw the item visual and draw it's label below
        ui.drawItem(i,x+2,y+2,h-4,h-4);
        var text	=	"";
        //if(qatapult.getArgValue(i,"email")!="")
          //  var text=" <"+qatapult.getArgValue(i,"email")+">";
        ui.drawEmphased(qatapult.getArgValue(i,"text")+text,qatapult.getQuery(i),x+h,y+10,w-2*h,30);
    }
}

//	ui.drawBitmap(Skin+"ui-radio-button.png", SkinWidth-33, SkinBorder+2, 16, 16);
function onClick(x,y) 
{
    if(x > SkinWidth-33 && x < SkinWidth-17 && y > SkinBorder + 2 && y < SkinBorder + 18)
        qatapult.showmenu(x,y);
}
